package asmc

import (
	"math"

	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/x86"
)

func (c *compiler) load(x asm.Instruction) {
	switch operands := x.Data.(type) {
	case *asm.MemoryRegister:
		if operands.Address.OffsetRegister == math.MaxUint8 {
			c.code = x86.LoadRegister(c.code, operands.Register, operands.Address.Offset, operands.Address.Length, operands.Address.Base)
		} else {
			c.code = x86.LoadDynamicRegister(c.code, operands.Register, operands.Address.OffsetRegister, operands.Address.Length, operands.Address.Base)
		}
	}
}
